namespace IrrlichtNetSwig
{
    public partial class arraySceneNode
    {
        public ISceneNode this[uint index]
        {
            get
            {
                if (index < 0 || size() < index)
                {
                    throw new System.IndexOutOfRangeException();
                }
                return getValue(index);
            }
            set
            {
                if (index < 0 || size() < index)
                {
                    throw new System.IndexOutOfRangeException();
                }
                setValue(index, value);
            }
        }
        public void set_pointer(ISceneNode[] pointer)
        {
            set_pointer((arraySceneNode)pointer, (uint)pointer.Length);
        }
        public static implicit operator arraySceneNode(ISceneNode[] other)
        {
            var arr = new arraySceneNode((uint)other.Length);
            for (uint i = 0; i < other.Length; i++)
            {
                arr.push_back(other[i]);
            }
            return arr;
        }
        public ISceneNode[] ToArray()
        {
            var arr = new ISceneNode[size()];
            for (uint i = 0; i < size(); i++)
            {
                arr[i] = this.getValue(i);
            }
            return arr;
        }
    }
}